﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Microsoft.Win32;
using Infragistics.Win;
using Infragistics.Win.UltraWinExplorerBar;
using Infragistics.Win.UltraWinTree;
using Infragistics.Win.UltraWinEditors;
using Infragistics.Win.UltraWinDataSource;

namespace RefreshCrashTree
{
    public partial class Form1 : Form
    {
        private UltraCheckEditor _cb = new UltraCheckEditor();

        public Form1()
        {
            InitializeComponent();
            Refresher();
//            this.BeginInvoke(new MethodInvoker(this.Refresher));
        }

        private UltraDataRow SetBOMRow(Boolean bReview, string sCode, string sDesc, UltraDataBand band)
        {
            object[] values = { bReview, sCode, sDesc };
            return band.DataSource.Rows.Add(values);
        }

        private UltraDataRow SetMaterialRow(Boolean bReview, string sCode, bool bReplaceable, string sDesc, string sTag, UltraDataRow parentRow)
        {
            object[] values = { bReview, sCode, bReplaceable, sDesc };

            // Get a reference to the Rows collection that represents this row's child rows under the desired band
            UltraDataRowsCollection childRows = parentRow.GetChildRows(sTag);

            // Add the row we want to add
            UltraDataRow newChildRow = childRows.Add(values);

            return newChildRow;
        }

        private UltraDataRow SetRSPLRow(string sCode, string sDesc, string sTag, UltraDataRow parentRow)
        {
            object[] values = { sCode, sDesc };

            // Get a reference to the Rows collection that represents this row's child rows under the desired band
            UltraDataRowsCollection childRows = parentRow.GetChildRows(sTag);

            // Add the row we want to add
            UltraDataRow newChildRow = childRows.Add(values);

            return newChildRow;
        }

        private void Refresher()
        {
            ultraTree1.SelectedNodes.Clear();

            try
            {
                string childNodeText;

                //this.ultraTree1.Nodes.Clear();
                ultraTree1.ColumnSettings.BorderStyleCell = UIElementBorderStyle.None;
                TreeDS.Rows.Clear();

                UltraDataRow prevBOM = null;
                UltraDataRow prevMaterial = null;
                UltraDataRow prevChildMaterial = null;

                Random rand = new Random();

                for (int ix = 0; ix < 10; ix++)
                {
                    int iKey = rand.Next();

                    String sKey = iKey.ToString(); /*Key*/
                    childNodeText = sKey;

                    bool bReview = false;
                    bool bReplace = false;

                    string sDesc = "Desc " + ix.ToString();

                    switch (ix)
                    {
                        case 0:
                        case 5:
                            prevBOM = SetBOMRow(bReview, childNodeText, sDesc, TreeDS.Band);
                            break;
                        case 1:
                        case 6:
                            prevMaterial = SetMaterialRow(bReview, childNodeText, bReplace, sDesc, "Material", prevBOM);
                            break;
                        case 2:
                        case 7:
                            prevChildMaterial = SetMaterialRow(bReview, childNodeText, bReplace, sDesc, "ChildMaterial", prevMaterial);
                            break;
                        case 3:
                        case 8:
                            SetRSPLRow(childNodeText, sDesc, "MaterialRSPL", prevMaterial);
                            break;
                        case 4:
                        case 9:
                            SetRSPLRow(childNodeText, sDesc, "ChildMaterialRSPL", prevChildMaterial);
                            break;
                    }
                }

                ultraTree1.DataSource = TreeDS;

                foreach (UltraTreeNode BOMParentNode in this.ultraTree1.Nodes)
                {
                    BOMParentNode.Text = "BOMs - All Unique BOMs";
                    foreach (UltraTreeNode BOMNode in BOMParentNode.Nodes)
                    {
                        BOMNode.Override.NodeAppearance.ForeColor = Color.Green;
                        BOMNode.Cells["Reviewed"].EditorComponent = _cb;

                        BOMNode.Override.CellClickAction = CellClickAction.EditCell;

                        foreach (UltraTreeNode MaterialNode in BOMNode.Nodes)
                        {
                            MaterialNode.Override.NodeAppearance.ForeColor = Color.Blue;
                            MaterialNode.Cells["Reviewed"].EditorComponent = _cb;
                            MaterialNode.Cells["Replaceable"].EditorComponent = _cb;

                            if (MaterialNode.BandName == "Material")
                            {
                                MaterialNode.Override.CellClickAction = CellClickAction.EditCell;
                            }
                            foreach (UltraTreeNode BOMChildChild in MaterialNode.Nodes)
                            {
                                if (BOMChildChild.BandName == "ChildMaterial")
                                {
                                    BOMChildChild.Text = "Child Material";
                                    BOMChildChild.Override.NodeAppearance.ForeColor = Color.Blue;

                                    if (BOMChildChild.Nodes.Count > 0)
                                        MaterialNode.Visible = true;

                                    foreach (UltraTreeNode ChildMaterialNode in BOMChildChild.Nodes)
                                    {
                                        ChildMaterialNode.Override.NodeAppearance.ForeColor = Color.Blue;
                                        ChildMaterialNode.Cells["Reviewed"].EditorComponent = _cb;
                                        ChildMaterialNode.Cells["Replaceable"].EditorComponent = _cb;

                                        ChildMaterialNode.Override.CellClickAction = CellClickAction.EditCell;

                                        foreach (UltraTreeNode BOMChildMaterialRSPLNode in ChildMaterialNode.Nodes)
                                        {
                                            BOMChildMaterialRSPLNode.Text = "RSPL";
                                            BOMChildMaterialRSPLNode.Override.NodeAppearance.ForeColor = Color.Fuchsia;
                                        }
                                    }

                                    bool bHideParent = true;
                                    foreach (UltraTreeNode ChildMaterialNode in BOMChildChild.Nodes)
                                    {
                                        if (ChildMaterialNode.Visible)
                                        {
                                            bHideParent = false;
                                            break;
                                        }
                                    }
                                    BOMChildChild.Visible = !bHideParent;
                                }
                                else if (BOMChildChild.BandName == "MaterialRSPL")
                                {

                                    BOMChildChild.Text = "RSPL";
                                    BOMChildChild.Override.NodeAppearance.ForeColor = Color.Fuchsia;

                                    foreach (UltraTreeNode MaterialRSPLNode in BOMChildChild.Nodes)
                                    {
                                        MaterialRSPLNode.Override.NodeAppearance.ForeColor = Color.Fuchsia;
                                    }
                                }
                            }
                        }
                    }
                }

                ultraTree1.NodeLevelOverrides[0].CellClickAction = CellClickAction.SelectNodeOnly;

                // default to ExpandAll
                this.ultraTree1.ExpandAll();
                this.ultraTree1.SelectedNodes.Clear();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void OnKeyDown(object sender, KeyEventArgs e)
        {
//            if(e.KeyCode == Keys.F5)
  //              Refresher();
        }

        private void OnRefresh(object sender, EventArgs e)
        {
//            Refresher();
            this.BeginInvoke(new MethodInvoker(this.Refresher));
        }

        private void OnKeyUp(object sender, KeyEventArgs e)
        {
//            Refresher();
            if(e.KeyCode == Keys.F5)
                this.BeginInvoke(new MethodInvoker(this.Refresher));
        }
    }
}
